---
apiVersion: kyverno.io/v1
kind: ClusterPolicy
metadata:
  name: fix-nginx-ingress-class-annotation-and-type
spec:
  rules:
    - name: 01-add-ingress-class-name
      match:
        any:
        - resources:
            annotations:
              kubernetes.io/ingress.class: "?*"
            kinds:
            - networking.k8s.io/v1/Ingress
            operations:
            - CREATE
            - UPDATE
      mutate:
        patchesJson6902: |-
          - path: "/metadata/annotations/int.skao.kyverno-mutation-ingress-deprecation"
            value: "fixed annotations/kubernetes.io/ingress.class deprecation"
            op: "add"
          - path: "/spec/ingressClassName"
            value: {{ request.object.metadata.annotations."kubernetes.io/ingress.class" }}
            op: "add"
          - path: "/metadata/annotations/kubernetes.io~1ingress.class"
            op: "remove"

    - name: 02-change-path-type
      preconditions:
        any:
        - key: "{{request.object.spec.ingressClassName || '' }}"
          operator: Equals
          value: "nginx*"
        - key: "{{request.metadata.annotations.\"kubernetes.io/ingress.class\" || ''}}"
          operator: Equals
          value: "nginx*"
      match:
        any:
        - resources:
            kinds:
            - networking.k8s.io/v1/Ingress
            operations:
            - CREATE
            - UPDATE
      mutate:
        foreach:
          - list: request.object.spec.rules[]
            foreach:
              - list: "element.http.paths[]"
                patchesJson6902: |-
                  - path: /spec/rules/{{elementIndex0}}/http/paths/{{elementIndex1}}/pathType
                    op: replace
                    value: "ImplementationSpecific"
    - name: 03-change-path-type-label
      preconditions:
        any:
        - key: "{{request.object.spec.ingressClassName || ''}}"
          operator: Equals
          value: "nginx*"
        - key: "{{request.metadata.annotations.\"kubernetes.io/ingress.class\" || ''}}"
          operator: Equals
          value: "nginx*"
      match:
        any:
        - resources:
            kinds:
            - networking.k8s.io/v1/Ingress
            operations:
            - CREATE
            - UPDATE
      mutate:
        patchStrategicMerge:
          metadata:
            annotations:
              int.skao.kyverno-mutation-ingress-path-nginx: "fixed path type from Prefix to ImplementationSpecific for NGINX"
